           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                August 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_Prover = Csp_laws + Csp_xsymbol:

(*****************************************************************

         1. Csp-Prover
         2.
         3. 
         4. 

 *****************************************************************)

(*-------------------------------------------------------*
 |                                                       |
 |      adding ... to automatic simplification rules     |
 |                                                       |
 *-------------------------------------------------------*)

(* automatically unfolded functions *)

declare Ext_choice_step_def                        [simp]
declare Parallel_step_def                          [simp]
declare Hide_step_def                              [simp]
declare Rename_step_def                            [simp]
declare Sequence_step_def                          [simp]

(*-------------------------------------------------------------*
 |                                                             |
 |  Users may be sometimes required to apply "Int_prefix_def"  |
 |  for unfoling "! x:X ->csp P". Do you like the following ?  |
 |                                                             |
 |  declare Int_prefix_def                         [simp]      |
 |                                                             |
 |  Users may be sometimes required to apply "S_Prefix_def"    |
 |  for unfoling "a!!x: ->csp P". Do you like the following ?  |
 |                                                             |
 |  declare S_Prefix_def                           [simp]      |
 |                                                             |
 |  Users may be sometimes required to apply "R_Prefix_def"    |
 |  for unfoling "a??x:X ->csp P". Do you like the following ? |
 |                                                             |
 |  declare R_Prefix_def                           [simp]      |
 |                                                             |
 *-------------------------------------------------------------*)

(*                           NO                                *)

(*-------------------------------------------------------------------*
 |                                                                   |
 |  To unfold (resp. fold) syntactic-sugar for internal and external |
 |  choices, use "unfold csp_ss_def" (resp. "fold csp_ss_def").      |
 |                                                                   |
 *-------------------------------------------------------------------*)

lemmas csp_ss_def = I_Prefix_def R_Prefix_def S_Prefix_def
                    R_Int_bind_def Int_prefix_def

(*
declare I_Prefix_def                               [simp]
declare R_Prefix_def                               [simp]
declare S_Prefix_def                               [simp]
declare R_Int_bind_def                             [simp]
declare Int_prefix_def                             [simp]
*)

(*   "inj_on_def" is needed for resolving (inv f) in R_Prefix_def *)

declare inj_on_def                                 [simp]

(*------------------------------------*
 |                                    |
 |    laws automatically applied      |
 |                                    |
 *------------------------------------*)

(* intro! intro? are automatically applied by "rule".     *)
(* intro! is automatically applied by "rules" and "auto". *)

(* Csp_law_basic *)

declare csp_commut                                  [simp]

(*
declare csp_eq_ref                                  [intro?]
declare csp_ref_eq                                  [intro?]
declare csp_trans                                   [intro?]

declare csp_sym                                     [intro!]
declare csp_symE                                    [elim!]

declare csp_rw_right                                [intro?]
declare csp_rw_left                                 [intro?]
declare csp_tr_right                                [intro?]
declare csp_tr_left                                 [intro?]

declare csp_rule_rw                                 [intro?]
declare csp_rule_rev_rw                             [intro?]

declare csp_rule_tr                                 [intro?]
declare csp_rule_tr_eq                              [intro?]
declare csp_rule_tr_ref                             [intro?]

declare csp_activate                                [intro?]
declare csp_inactivate                              [intro?]
*)

(* csp_rule_rw, csp_rule_tr, and csp_rule_af are used for *)
(* making csp_rules.                                      *)

(* Csp_law_IF *)

declare csp_IF_split                                [simp]
declare csp_IF                                      [simp]

(*
declare csp_IF_split_rw                             [simp]
declare csp_IF_rw                                   [simp]
*)

(* Csp_law_ref *)

declare csp_Int_choice_right                        [intro!]
declare csp_Int_bind_right                          [intro!]

(* 
declare csp_Int_choice_left1                        [intro?]
declare csp_Int_choice_left2                        [intro?]
declare csp_Int_choice_left3                        [intro?]
declare csp_Int_bind_left                           [intro?]
declare csp_Int_bind_left_x                         [intro?]

declare csp_decompo_subset                          [intro?]
declare csp_Ext_choice_right                        [intro?]
*)

(* Csp_law_SKIP *)

declare csp_SKIP                                    [simp]
lemmas  csp_SKIP_sym                                [simp]
      = csp_SKIP[THEN csp_sym]

(*
declare csp_SKIP_rw                                 [simp]
*)

(* Csp_law_decompo *)

declare csp_decompo                                 [simp]
declare csp_rm_head                                 [intro!]

(*
declare csp_free_decompo                            [intro!] 
declare csp_decompo                                 [intro!] 
declare csp_free_decompo_left                       [intro!] 
declare csp_free_decompo_right                      [intro!] 
declare csp_decompo_left                            [intro!] 
declare csp_decompo_right                           [intro!] 

declare csp_free_decompo_af_left                    [intro!] 
declare csp_free_decompo_af_right                   [intro!] 
declare csp_decompo_af_left                         [intro!] 
declare csp_decompo_af_right                        [intro!] 
*)

(* Csp_law_dist *)

declare csp_dist                                    [simp]
lemmas  csp_dist_sym                                [simp]
      = csp_dist[THEN csp_sym]

(*
declare csp_dist_rw                                 [simp]
declare csp_dist_rw_left                            [simp]
declare csp_dist_rw_right                           [simp]
*)

declare csp_Dist                                    [simp]
lemmas  csp_Dist_sym                                [simp]
      = csp_Dist[THEN csp_sym]

(*
declare csp_Dist_rw                                 [simp]
declare csp_Dist_rw_left                            [simp]
declare csp_Dist_rw_right                           [simp]
*)

(* Csp_law_fp *)

declare csp_unwind                                  [simp]
lemmas  csp_unwind_sym                              [simp]
      = csp_unwind[THEN csp_sym]

declare csp_check                                   [intro!]
(*
declare csp_unwind_rw                               [simp]
declare csp_fp_induct                               [simp]
declare csp_fp_induct                               [intro!]
*)

(* Csp_law_step *)

declare csp_step                                    [simp]
lemmas  csp_step_sym                                [simp]
      = csp_step[THEN csp_sym]

(*
declare csp_step_rw                                 [simp]
declare csp_step_rw_left                            [simp]
declare csp_step_rw_right                           [simp]

declare light_csp_step_rw                           [simp]
declare light_csp_step_rw_left                      [simp]
declare light_csp_step_rw_right                     [simp]
*)

(* Csp_laws *)

declare csp_reflex_ex                               [simp]
declare csp_simp                                    [simp]
lemmas  csp_simp_sym                                [simp]
      = csp_simp[THEN csp_sym]

(*
declare csp_Int_simp_rw                             [simp]
declare csp_Ext_simp_rw                             [simp]
declare csp_Mix_simp_rw                             [simp]
declare csp_simp_rw                                 [simp]
declare csp_Timeout_right                           [intro!]
*)

(*================================================*
 |                                                |
 |                  Tacticals                     |
 |                                                |
 *================================================*)

lemmas csp_IF_simp_rw_right    = csp_IF_rw_right   csp_simp_rw_right
lemmas csp_IF_simp_rw_left     = csp_IF_rw_left    csp_simp_rw_left
lemmas csp_dist_Dist_rw_right  = csp_dist_rw_right csp_Dist_rw_right
lemmas csp_dist_Dist_rw_left   = csp_dist_rw_left  csp_Dist_rw_left

ML_setup {*
    val CSP_reflex                = thms "csp_reflex" ;
    val CSP_rm_head               = thms "csp_rm_head" ;
    val CSP_activate              = thms "csp_activate" ;
    val CSP_inactivate            = thms "csp_inactivate" ;
    val CSP_ss_def                = thms "csp_ss_def" ;

    val CSP_rw_left               = thms "csp_rw_left" ;
    val CSP_tr_left               = thms "csp_tr_left" ;
    val CSP_IF_simp_rw_left       = thms "csp_IF_simp_rw_left" ;
    val CSP_free_decompo_left     = thms "csp_free_decompo_left" ;
    val CSP_free_decompo_af_left  = thms "csp_free_decompo_af_left" ;
    val CSP_step_rw_left          = thms "csp_step_rw_left" ;
    val CSP_light_step_rw_left    = thms "csp_light_step_rw_left" ;
    val CSP_SKIP_rw_left          = thms "csp_SKIP_rw_left" ;
    val CSP_dist_Dist_rw_left     = thms "csp_dist_Dist_rw_left" ;
    val CSP_unwind_rw_left        = thms "csp_unwind_rw_left" ;

    val CSP_rw_right               = thms "csp_rw_right" ;
    val CSP_tr_right               = thms "csp_tr_right" ;
    val CSP_free_decompo_right     = thms "csp_free_decompo_right" ;
    val CSP_free_decompo_af_right  = thms "csp_free_decompo_af_right" ;
    val CSP_unwind_rw_right        = thms "csp_unwind_rw_right" ;
*}

(************************************************
                  rewrite left
 ************************************************)

(*-----------------------------------------------------*
      apply (tactic {* csp_hnf_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_step_rw_left
             | simp add: csp_dist_Dist_rw_left
             | simp add: csp_unwind_rw_left 
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_hnf_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_step_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_dist_Dist_rw_left) n)),
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_unwind_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_step_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_step_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_step_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_step_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_light_step_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_light_step_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_light_step_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_light_step_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_dist_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_dist_Dist_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_dist_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_dist_Dist_rw_left) n)),
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_unwind_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_unwind_rw_left 
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_unwind_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_unwind_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_left_tac add 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp add: add
             | simp add: csp_IF_simp_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_left_tac add n =
     let val ADD = thms add
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () addsimps ADD) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_del_left_tac del 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp del: del
             | simp add: csp_IF_simp_rw_left del: del
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_del_left_tac del n =
     let val DEL = thms del
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () delsimps DEL) n)) ,
            (CHANGED (asm_full_simp_tac 
                     (simpset () addsimps CSP_IF_simp_rw_left delsimps DEL) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_del_left_tac add del 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_left ,
             ((simp add: add del: del
             | simp add: csp_IF_simp_rw_left add del: del
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_del_left_tac add del n =
     let val ADD = thms add
         val DEL = thms del
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_left n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () addsimps ADD delsimps DEL) n)) ,
            (CHANGED (asm_full_simp_tac 
                     (simpset () addsimps CSP_IF_simp_rw_left delsimps DEL) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_rule_left_tac a 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_tr_left ,
             ((rule a
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_rule_left_tac a n =
     let val A = thms a
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_tr_left n,

         REPEAT (
          FIRST 
           [(CHANGED (resolve_tac A n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_asm_left_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_tr_left ,
             ((assumption
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_asm_left_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_tr_left n,

         REPEAT (
          FIRST 
           [(CHANGED (assume_tac n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(************************************************
                  rewrite right
 ************************************************)

(*-----------------------------------------------------*
      apply (tactic {* csp_hnf_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_step_rw_left
             | simp add: csp_dist_Dist_rw_left
             | simp add: csp_unwind_rw_left 
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_hnf_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_step_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_dist_Dist_rw_left) n)),
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_unwind_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_step_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_step_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_step_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_step_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_light_step_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_SKIP_rw_left
             | simp add: csp_light_step_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_light_step_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_SKIP_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_light_step_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_dist_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_dist_Dist_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_dist_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_dist_Dist_rw_left) n)),
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_unwind_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | simp add: csp_unwind_rw_left 
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_unwind_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_unwind_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp 
             | simp add: csp_IF_simp_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (Asm_full_simp_tac n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_right_tac add 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp add: add
             | simp add: csp_IF_simp_rw_left
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_right_tac add n =
     let val ADD = thms add
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () addsimps ADD) n)) ,
            (CHANGED (asm_full_simp_tac (simpset () addsimps CSP_IF_simp_rw_left) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_del_right_tac del 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp del: del
             | simp add: csp_IF_simp_rw_left del: del
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_del_right_tac del n =
     let val DEL = thms del
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () delsimps DEL) n)) ,
            (CHANGED (asm_full_simp_tac 
                     (simpset () addsimps CSP_IF_simp_rw_left delsimps DEL) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_del_right_tac add del 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_rw_right ,
             ((simp add: add del: del
             | simp add: csp_IF_simp_rw_left add del: del
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_del_right_tac add del n =
     let val ADD = thms add
         val DEL = thms del
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_rw_right n,

         REPEAT (
          FIRST 
           [(CHANGED (asm_full_simp_tac (simpset () addsimps ADD delsimps DEL) n)) ,
            (CHANGED (asm_full_simp_tac 
                     (simpset () addsimps CSP_IF_simp_rw_left delsimps DEL) n)) ,
            (resolve_tac CSP_free_decompo_af_left n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_rule_right_tac a 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_tr_right ,
             ((rule a
             | rule csp_free_decompo_af_left
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_rule_right_tac a n =
     let val A = thms a
     in
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_tr_right n,

         REPEAT (
          FIRST 
           [(CHANGED (resolve_tac A n)) ,
            (resolve_tac CSP_free_decompo_af_right n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
     end
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_asm_right_tac 1 *})
                      is equal to
      apply (rule csp_activate ,
             rule csp_tr_right ,
             ((assumption
             | rule csp_free_decompo_af_right
             | rule csp_inactivate
             | rule csp_reflex)+)? ,
             (rule csp_inactivate)?)
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_asm_right_tac n =
      CHANGED (
       EVERY
        [resolve_tac CSP_activate n,
         resolve_tac CSP_tr_right n,

         REPEAT (
          FIRST 
           [(CHANGED (assume_tac n)) ,
            (resolve_tac CSP_free_decompo_af_right n) ,
            (CHANGED (resolve_tac CSP_inactivate n)) ,
            (resolve_tac CSP_reflex n)]) ,

         TRY (resolve_tac CSP_inactivate n)])
*}

(************************************************
                 rewrite both
 ************************************************)

(*-----------------------------------------------------*
      apply (tactic {* csp_hnf_tac 1 *})
                      is equal to
      apply ((tactic {* csp_hnf_left_tac 1 *})+)? ,
            ((tactic {* csp_hnf_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_hnf_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_hnf_left_tac n),
         REPEAT (csp_hnf_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_step_tac 1 *})
                      is equal to
      apply ((tactic {* csp_step_left_tac 1 *})+)? ,
            ((tactic {* csp_step_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_step_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_step_left_tac n),
         REPEAT (csp_step_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_light_step_tac 1 *})
                      is equal to
      apply ((tactic {* csp_light_step_left_tac 1 *})+)? ,
            ((tactic {* csp_light_step_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_light_step_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_light_step_left_tac n),
         REPEAT (csp_light_step_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_dist_tac 1 *})
                      is equal to
      apply ((tactic {* csp_dist_left_tac 1 *})+)? ,
            ((tactic {* csp_dist_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_dist_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_dist_left_tac n),
         REPEAT (csp_dist_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_unwind_tac 1 *})
                      is equal to
      apply ((tactic {* csp_unwind_left_tac 1 *})+)? ,
            ((tactic {* csp_unwind_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_unwind_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_unwind_left_tac n),
         REPEAT (csp_unwind_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_tac 1 *})
                      is equal to
      apply ((tactic {* csp_simp_left_tac 1 *})+)? ,
            ((tactic {* csp_simp_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_simp_left_tac n),
         REPEAT (csp_simp_right_tac n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_tac add 1 *})
                      is equal to
      apply ((tactic {* csp_simp_add_left_tac add 1 *})+)? ,
            ((tactic {* csp_simp_add_right_tac add 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_tac add n = 
      CHANGED (
       EVERY
        [REPEAT (csp_simp_add_left_tac add n),
         REPEAT (csp_simp_add_right_tac add n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_del_tac del 1 *})
                      is equal to
      apply ((tactic {* csp_simp_del_left_tac del 1 *})+)? ,
            ((tactic {* csp_simp_del_right_tac del 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_del_tac del n = 
      CHANGED (
       EVERY
        [REPEAT (csp_simp_del_left_tac del n),
         REPEAT (csp_simp_del_right_tac del n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_simp_add_del_tac add del 1 *})
                      is equal to
      apply ((tactic {* csp_simp_add_del_left_tac add del 1 *})+)? ,
            ((tactic {* csp_simp_add_del_right_tac add del 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_simp_add_del_tac add del n = 
      CHANGED (
       EVERY
        [REPEAT (csp_simp_add_del_left_tac add del n),
         REPEAT (csp_simp_add_del_right_tac add del n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_rule_tac a 1 *})
                      is equal to
      apply ((tactic {* csp_rule_left_tac a 1 *})+)? ,
            ((tactic {* csp_rule_right_tac a 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_rule_tac a n = 
      CHANGED (
       EVERY
        [REPEAT (csp_rule_left_tac a n),
         REPEAT (csp_rule_right_tac a n)])
*}

(*-----------------------------------------------------*
      apply (tactic {* csp_asm_tac 1 *})
                      is equal to
      apply ((tactic {* csp_asm_left_tac 1 *})+)? ,
            ((tactic {* csp_asm_right_tac 1 *})+)?
 *-----------------------------------------------------*)

ML_setup {*
    fun csp_asm_tac n = 
      CHANGED (
       EVERY
        [REPEAT (csp_asm_left_tac n),
         REPEAT (csp_asm_right_tac n)])
*}

end
