           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_STOP = Csp_semantics:

(*****************************************************************

         1. STOPt  : dom_T
         2. STOPf  : dom_F
         3. STOPsf : dom_SF
         4. 

 *****************************************************************)

(*********************************************************
                 Lemmas ( STOPsf : dom_SF)
 *********************************************************)

(*** STOPt in dom_T ***)

lemma STOPt_in : "STOPt: dom_T"
apply (simp add: STOPt_def)
apply (simp add: nil_t_set_in)
done

(*** STOPf in dom_F ***)

lemma STOPf_in : "STOPf: dom_F"
apply (simp add: STOPf_def)
apply (simp add: nil_t_in_dom_F)
done


(*******************************
       STOPsf in dom_SF
 *******************************)

(* T2 *)

lemma STOPsf_in_T2 : "CT2 STOPsf"
apply (simp add: STOPsf_def CT2_def)
apply (intro allI impI)
apply (simp add: STOPt_in Abs_dom_T_inverse)
apply (simp add: STOPf_in Abs_dom_F_inverse)

apply (simp add: STOPt_def STOPf_def)

apply (erule conjE)
apply (simp add: appt_to_app_or_sym)
apply (simp add: event_in_trace nil_in_trace Abs_trace_inverse)
done

(* F2 *)

lemma STOPsf_in_F2 : "CF2 STOPsf"
apply (simp add: STOPsf_def CF2_def)
apply (intro allI impI)
apply (simp add: STOPf_in Abs_dom_F_inverse)

apply (simp add: STOPf_def)
apply (simp add: EvsetTick_def)
done

(* F3 *)

lemma STOPsf_in_F3 : "CF3 STOPsf"
apply (simp add: STOPsf_def CF3_def)
apply (intro allI impI)
apply (simp add: STOPt_in Abs_dom_T_inverse)
apply (simp add: STOPf_in Abs_dom_F_inverse)

apply (auto simp add: STOPt_def STOPf_def)
done

(*** STOPsf in dom_SF ***)

lemma STOPsf_in : "STOPsf: dom_SF"
apply (simp add: dom_SF_def)
apply (simp add: STOPsf_in_T2)
apply (simp add: STOPsf_in_F2)
apply (simp add: STOPsf_in_F3)
done

(*********************************************************
                  STOP trace eval
 *********************************************************)

lemma STOPt_eval: "ALL ev. [[STOP]]T ev = STOPt"
apply (intro allI)
apply (simp add: eval_T_def)
apply (simp add: STOPsf_def)
apply (simp add: STOPt_in Abs_dom_T_inverse)
done

(*********************************************************
                  STOP failure eval
 *********************************************************)

lemma STOPf_eval: "ALL ev. [[STOP]]F ev = STOPf"
apply (intro allI)
apply (simp add: eval_F_def)
apply (simp add: STOPsf_def)
apply (simp add: STOPf_in Abs_dom_F_inverse)
done

end
