           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Prefix = Csp_Prefix:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*****************************************************************

         1. a ->sf SF : contraction map
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                   rest prefix trace
 *********************************************************)

(*** only if (<=) ***)

lemma rest_Prefixt_only_if_sub :
  "ALL a S T n. S: dom_T & T: dom_T &
    (Abs_dom_T (a ->t S)) rest (Suc n) <= (Abs_dom_T (a ->t T)) rest (Suc n)
     --> (Abs_dom_T S) rest n <= (Abs_dom_T T) rest n"
apply (intro allI impI)
apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Prefixt_in Abs_dom_T_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (simp add: Prefixt_def)

apply (drule_tac x="[Ev a]t @t x" in spec)

apply (simp add: nil_in_trace event_in_trace Abs_trace_inverse)
apply (simp add: event_app_in_trace Abs_trace_inverse Rep_trace
                 nil_in_trace Abs_trace_inject)

apply (drule mp)
apply (rule_tac x="x" in exI)
apply (simp)

apply (erule exE)
apply (simp add: Rep_trace_inject)
done

(*** only if ***)

lemma rest_Prefixt_only_if:
  "ALL a  S T n. S: dom_T & T: dom_T &
    (Abs_dom_T (a ->t S)) rest (Suc n) = (Abs_dom_T (a ->t T)) rest (Suc n)
     --> (Abs_dom_T S) rest n = (Abs_dom_T T) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (insert rest_Prefixt_only_if_sub)
apply (drule_tac x="a" in spec)
apply (drule_tac x="S" in spec)
apply (drule_tac x="T" in spec)
apply (drule_tac x="n" in spec)
apply (simp)

apply (drule_tac x="a" in spec)
apply (drule_tac x="T" in spec)
apply (drule_tac x="S" in spec)
apply (drule_tac x="n" in spec)
apply (simp)
done

(*** if (<=) ***)

lemma rest_Prefixt_if_sub :
  "ALL a S T n. S: dom_T & T: dom_T &
    (Abs_dom_T S) rest n <= (Abs_dom_T T) rest n
  --> (Abs_dom_T (a ->t S)) rest (Suc n) <= (Abs_dom_T (a ->t T)) rest (Suc n)"
apply (intro allI impI)
apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Prefixt_in Abs_dom_T_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (simp add: Prefixt_def)
apply (erule conjE)
apply (erule disjE)
apply (simp)

apply (rule disjI2)
apply (elim conjE exE)
apply (rule_tac x="s" in exI)

apply (drule_tac x="s" in spec)

apply (simp add: nil_in_trace event_in_trace Abs_trace_inverse)
apply (simp add: event_app_in_trace Abs_trace_inverse Rep_trace)
done

(*** if ***)

lemma rest_Prefixt_if :
  "ALL a S T n. S: dom_T & T: dom_T &
    (Abs_dom_T S) rest n = (Abs_dom_T T) rest n
  --> (Abs_dom_T (a ->t S)) rest (Suc n) = (Abs_dom_T (a ->t T)) rest (Suc n)"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Prefixt_if_sub)
done

(*** iff ***)

lemma rest_Prefixt_iff :
  "ALL a S T n. S: dom_T & T: dom_T -->
   ((Abs_dom_T (a ->t S)) rest (Suc n) = (Abs_dom_T (a ->t T)) rest (Suc n))
       = ((Abs_dom_T S) rest n = (Abs_dom_T T) rest n)"
apply (intro allI impI)
apply (rule iffI)
apply (insert rest_Prefixt_only_if)
apply (drule_tac x="a" in spec)
apply (drule_tac x="S" in spec)
apply (drule_tac x="T" in spec)
apply (drule_tac x="n" in spec)
apply (simp)
apply (simp add: rest_Prefixt_if)
done

(*********************************************************
                   rest prefix fialure
 *********************************************************)

(*** only if (<=) ***)

lemma rest_Prefixf_only_if_sub :
  "ALL a E F n. E: dom_F & F: dom_F &
    (Abs_dom_F (a ->f E)) rest (Suc n) <= (Abs_dom_F (a ->f F)) rest (Suc n)
     --> (Abs_dom_F E) rest n <= (Abs_dom_F F) rest n"
apply (intro allI impI)
apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Prefixf_in Abs_dom_F_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (rename_tac a E F n s X)
apply (simp add: Prefixf_def)

apply (drule_tac x="[Ev a]t @t s" in spec)
apply (drule_tac x="X" in spec)

apply (simp add: nil_in_trace event_in_trace Abs_trace_inverse)
apply (simp add: event_app_in_trace Abs_trace_inverse Rep_trace
                 nil_in_trace Abs_trace_inject)
apply (drule mp)

apply (erule conjE)+
apply (rule conjI)
apply (rule_tac x="s" in exI)
apply (simp)

      (* < *)

apply (erule disjE)
apply (rule disjI1)
apply (simp)

      (* = Tick *)

apply (rule disjI2)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="[Ev a]t @t s'" in exI)
apply (simp add: Ev_app_notick)

apply (simp add: event_in_trace Abs_trace_inverse)
apply (simp add: event_app_in_trace Abs_trace_inverse Rep_trace)

apply (simp add: app_trace_notick event_in_trace Abs_trace_inverse Rep_trace)

apply (simp)
apply (elim conjE exE)
apply (simp add: Rep_trace_inject)
done

(*** only if ***)

lemma rest_Prefixf_only_if :
  "ALL a E F n. E: dom_F & F: dom_F &
    (Abs_dom_F (a ->f E)) rest (Suc n) = (Abs_dom_F (a ->f F)) rest (Suc n)
     --> (Abs_dom_F E) rest n = (Abs_dom_F F) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (insert rest_Prefixf_only_if_sub)
apply (drule_tac x="a" in spec)
apply (drule_tac x="E" in spec)
apply (drule_tac x="F" in spec)
apply (drule_tac x="n" in spec)
apply (simp)

apply (drule_tac x="a" in spec)
apply (drule_tac x="F" in spec)
apply (drule_tac x="E" in spec)
apply (drule_tac x="n" in spec)
apply (simp)
done

(*** if (<=) ***)

lemma rest_Prefixf_if_sub :
  "ALL a E F n. E: dom_F & F: dom_F &
    ((Abs_dom_F E) rest n <= (Abs_dom_F F) rest n)
  --> (Abs_dom_F (a ->f E)) rest (Suc n) <= (Abs_dom_F (a ->f F)) rest (Suc n)"
apply (intro allI impI)
apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Prefixf_in Abs_dom_F_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (rename_tac a E F n s X)

apply (erule conjE)+
apply (simp add: Prefixf_def)

      (* s = []t *)

apply (erule disjE)
apply (simp)

      (* s = s = [Ev a]t @t t *)

apply (elim conjE exE)
apply (rename_tac a E F n s X t)
apply (rule disjI2)

         (* lengtht s < Suc n *)

apply (erule disjE)
apply (drule_tac x="t" in spec)
apply (drule_tac x="X" in spec)
apply (drule mp)
apply (simp add: event_in_trace Abs_trace_inverse)
apply (simp add: event_app_in_trace Abs_trace_inverse Rep_trace)

apply (rule_tac x="t" in exI)
apply (simp)

         (* lengtht s = Suc n & s = s' @t [Tick]t *)

apply (elim conjE exE)
apply (insert trace_nil_or_Tick_or_Ev)
apply (rotate_tac -1)
apply (drule_tac x="s'" in spec)

            (* s' = []t --> contradiction (Ev a ~= Tick) *)

apply (erule disjE)
apply (simp add: nil_in_trace event_in_trace Abs_trace_inverse)
apply (simp add: event_in_trace event_app_in_trace Abs_trace_inject Rep_trace)

            (* s' = [Tick]t --> contradiction (notick s') *)

apply (erule disjE)
apply (simp add: event_in_trace Abs_trace_inverse)

            (* s' = [Ev b]t @t s'' *)

apply (elim conjE exE)
apply (rename_tac a E F n s X t s' b s'')
apply (simp)
apply (rule_tac x="t" in exI)

apply (drule_tac x="t" in spec)
apply (drule_tac x="X" in spec)
apply (drule mp)
apply (simp)
apply (rule disjI2)
apply (simp add: event_in_trace Abs_trace_inverse event_app_in_trace 
                 Rep_trace app_trace_notick Abs_trace_inject)
apply (rule_tac x="s''" in exI)
apply (simp add: app_trace_notick event_in_trace Rep_trace Abs_trace_inverse)
apply (simp add: Rep_trace_inverse)
apply (simp)
done

(*** if ***)

lemma rest_Prefixf_if :
  "ALL a E F n. E: dom_F & F: dom_F &
    ((Abs_dom_F E) rest n = (Abs_dom_F F) rest n)
  --> (Abs_dom_F (a ->f E)) rest (Suc n) = (Abs_dom_F (a ->f F)) rest (Suc n)"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Prefixf_if_sub)
done

(*** iff ***)

lemma rest_Prefixf_iff :
  "ALL a E F n. E: dom_F & F: dom_F -->
   ((Abs_dom_F (a ->f E)) rest (Suc n) = (Abs_dom_F (a ->f F)) rest (Suc n))
     = ((Abs_dom_F E) rest n = (Abs_dom_F F) rest n)"
apply (intro allI impI)
apply (rule iffI)
apply (insert rest_Prefixf_only_if)
apply (drule_tac x="a" in spec)
apply (drule_tac x="E" in spec)
apply (drule_tac x="F" in spec)
apply (drule_tac x="n" in spec)
apply (simp)
apply (simp add: rest_Prefixf_if)
done

(*********************************************************
                      dis prefixt
 *********************************************************)

lemma dis_Prefixt:
  "ALL a S T. S: dom_T & T: dom_T -->
       distance(Abs_dom_T (a ->t S), Abs_dom_T (a ->t T)) =
       (1/2) * distance(Abs_dom_T S, Abs_dom_T T)"
apply (intro allI impI)
apply (insert rest_to_dis_plus)
apply (drule_tac x="1" in spec)
apply (drule_tac x="Abs_dom_T S" in spec)
apply (drule_tac x="Abs_dom_T T" in spec)
apply (drule_tac x="Abs_dom_T (a ->t S)" in spec)
apply (drule_tac x="Abs_dom_T (a ->t T)" in spec)
apply (simp add: rest_Prefixt_iff)
done

(*********************************************************
                      dis prefixf
 *********************************************************)

lemma dis_Prefixf:
  "ALL a E F. E: dom_F & F: dom_F -->
       distance(Abs_dom_F (a ->f E), Abs_dom_F (a ->f F)) =
       (1/2) * distance(Abs_dom_F E, Abs_dom_F F)"
apply (intro allI impI)
apply (insert rest_to_dis_plus)
apply (drule_tac x="1" in spec)
apply (drule_tac x="Abs_dom_F E" in spec)
apply (drule_tac x="Abs_dom_F F" in spec)
apply (drule_tac x="Abs_dom_F (a ->f E)" in spec)
apply (drule_tac x="Abs_dom_F (a ->f F)" in spec)
apply (simp add: rest_Prefixf_iff)
done

(*********************************************************
                      dis prefixsf
 *********************************************************)

lemma dis_Prefixsf:
  "ALL a SE TF. distance(a ->sf SE, a ->sf TF) = (1/2) * distance(SE, TF)"
apply (intro allI impI)
apply (simp add: Prefixsf_def)
apply (simp add: pair_distance)

apply (simp add: dis_Prefixt Rep_dom_T Rep_dom_T_inverse)
apply (simp add: dis_Prefixf Rep_dom_F Rep_dom_F_inverse)
apply (simp add: max_def)
done


(****************** to add them again ******************)

declare disj_not1 [simp]

end
