           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Sequence = Csp_Sequence:

(*****************************************************************

         1. SF ;;sf SF : non-expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                    rest rest_Sequencet
 *********************************************************)

(*** (<=) ***)

(* lm 1 *)

lemma rest_Sequencet_sub_lm1 :
   "!!S1 S2 T1 T2 n x.
       [| S1 : dom_T; S2 : dom_T; T1 : dom_T; T2 : dom_T;
          ALL x. x : S1 & lengtht x <= n --> x : T1; lengtht x <= n;
          EX s. x = rmtick s & s : S1 |]
       ==> EX s. x = rmtick s & s : T1"
apply (elim conjE exE)

apply (insert rmtick_trace)
apply (rotate_tac -1)
apply (drule_tac x="s" in spec)
apply (erule disjE)

apply (rule_tac x="s" in exI)
apply (drule_tac x="s" in spec)
apply (simp)

apply (rule_tac x="x" in exI)
apply (simp add: rmtick_is_notick rmtick_notick)
apply (drule_tac x="rmtick s" in spec)
apply (drule mp)

apply (insert dom_T_is_prefix_closed)
apply (drule_tac x="rmtick s" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="S1" in spec)
apply (drule mp)

apply (simp add: prefix_list_def)
apply (simp add: Rep_trace)
apply (rule_tac x="Rep_trace [Tick]t" in exI)

apply (insert trace_app_in_trace_if)
apply (drule_tac x="rmtick s" in spec)
apply (drule_tac x="[Tick]t" in spec)
apply (simp add: rmtick_is_notick)
apply (simp add: Abs_Rep_t)

apply (simp)
apply (simp)
done

(* lm 2 *)

lemma rest_Sequencet_sub_lm2 :
   "!!S1 S2 T1 T2 n x s t.
       [| S1 : dom_T; S2 : dom_T; T1 : dom_T; T2 : dom_T;
          ALL x. x : S1 & lengtht x <= n --> x : T1; lengtht (s @t []t) <= n;
          x = s @t []t; notick s; s @t [Tick]t : S1; []t : S2; t = []t |]
       ==> EX sa. s @t []t = rmtick sa & sa : T1"
apply (rule_tac x="s" in exI)
apply (simp add: nil_in_trace Abs_trace_inverse Rep_trace_inverse)
apply (simp add: rmtick_is_notick rmtick_notick)

apply (drule_tac x="s" in spec)
apply (drule mp)

apply (insert dom_T_is_prefix_closed)
apply (drule_tac x="s" in spec)
apply (drule_tac x="s @t [Tick]t" in spec)
apply (drule_tac x="S1" in spec)
apply (drule mp)

apply (simp add: prefix_list_def)
apply (simp add: Rep_trace)
apply (rule_tac x="Rep_trace [Tick]t" in exI)

apply (insert trace_app_in_trace_if)
apply (drule_tac x="s" in spec)
apply (drule_tac x="[Tick]t" in spec)
apply (simp)
apply (simp add: Abs_trace_inverse)

apply (simp)
apply (simp)
done

(* main *)

lemma rest_Sequencet_sub :
  "ALL S1 S2 T1 T2 n. S1:dom_T & S2:dom_T & T1:dom_T & T2:dom_T &
        (Abs_dom_T S1) rest n <= (Abs_dom_T T1) rest n &
        (Abs_dom_T S2) rest n <= (Abs_dom_T T2) rest n
     --> Abs_dom_T (S1 ;;t S2) rest n <= 
         Abs_dom_T (T1 ;;t T2) rest n"

apply (intro allI impI)
apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Sequencet_in Abs_dom_T_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (simp add: Sequencet_def)
apply (elim conjE exE)
apply (erule disjE)

 (*  x = rmtick s *)
apply (simp add: rest_Sequencet_sub_lm1)

 (*  x = s @t t *)
apply (elim conjE exE)

apply (insert trace_last_nil_or_unnil)
apply (rotate_tac -1)
apply (drule_tac x="t" in spec)
apply (erule disjE)

 (* t = []t *)
apply (simp add: rest_Sequencet_sub_lm2)

 (* t = sa @t [a]t *)
apply (rule disjI2)
apply (elim conjE exE)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)

apply (drule_tac x="s @t [Tick]t" in spec)
apply (drule_tac x="sa @t [a]t" in spec)
apply (simp)
apply (drule mp)
apply (simp add: length_app_decompo)
apply (simp add: event_in_trace Abs_trace_inverse)

apply (drule mp)
apply (simp add: app_trace_notick_ass)
apply (simp add: app_trace_notick_notick length_app_decompo)

apply (simp)
done

(*** (=) ***)

lemma rest_Sequencet :
  "ALL S1 S2 T1 T2 n. S1:dom_T & S2:dom_T & T1:dom_T & T2:dom_T &
        (Abs_dom_T S1) rest n = (Abs_dom_T T1) rest n &
        (Abs_dom_T S2) rest n = (Abs_dom_T T2) rest n
     --> Abs_dom_T (S1 ;;t S2) rest n = 
         Abs_dom_T (T1 ;;t T2) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Sequencet_sub)
done

(*********************************************************
                    rest Sequencef
 *********************************************************)

(*** (<=) ***)

lemma rest_Sequencef_sub :
  "ALL S1 E1 E2 T1 F1 F2 n. 
         S1:dom_T & E1:dom_F & E2:dom_F & T1:dom_T & F1:dom_F & F2:dom_F &
        (Abs_dom_T S1) rest n <= (Abs_dom_T T1) rest n &
        (Abs_dom_F E1) rest n <= (Abs_dom_F F1) rest n &
        (Abs_dom_F E2) rest n <= (Abs_dom_F F2) rest n
     --> Abs_dom_F ((S1, E1) ;;f E2) rest n <= 
         Abs_dom_F ((T1, F1) ;;f F2) rest n"

apply (intro allI impI)
apply (simp (no_asm) add: rest_F_def)
apply (simp (no_asm) add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Sequencef_in Abs_dom_F_inverse)

apply (rule subsetI)
apply (simp add: Sequencef_def del: split_eta_SetCompr2)
apply (elim conjE exE)

 (* s *)

 apply (erule disjE)
 apply (elim conjE exE)
 apply (simp)

  (* lengtht s < n *)

  apply (erule disjE)

  apply (simp add: rest_F_def)
  apply (simp add: subset_F_def)
  apply (simp add: restFset_in Abs_dom_F_inverse)
  apply (simp add: restFset_def)

  apply (erule subsetE)
  apply (drule_tac x="(s, insert Tick X)" in bspec)
  apply (simp add: Abs_dom_F_inverse)
  apply (simp add: Abs_dom_F_inverse)

  (* lengtht s = n --> contra *)
  apply (elim conjE exE)
  apply (simp add: trace_app_in_trace_if Abs_trace_inverse)
  apply (simp add: event_in_trace Abs_trace_inverse)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp)
 apply (elim conjE)

 apply (rotate_tac -2)
 apply (drule sym)
 apply (simp)

  (* lengtht (sa @t t) < n *)
  apply (erule disjE)
  apply (rule disjI2)
  apply (rule_tac x="sa" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

  (* F2 *)
  apply (simp add: rest_F_def)
  apply (simp add: subset_F_def)
  apply (simp add: restFset_in Abs_dom_F_inverse)
  apply (simp add: restFset_def)

  apply (rotate_tac -7)
  apply (erule subsetE)
  apply (drule_tac x="(t, X)" in bspec)
   apply (simp add: Abs_dom_F_inverse)
   apply (simp add: length_app_decompo)
  apply (simp add: Abs_dom_F_inverse)

  (* T1 *)
  apply (simp add: rest_T_def)
  apply (simp add: subset_T_def)
  apply (simp add: restTset_in Abs_dom_T_inverse)
  apply (simp add: restTset_def)
  apply (erule subsetE)
  apply (drule_tac x="sa @t [Tick]t" in bspec)

   apply (simp add: Abs_dom_T_inverse)
   apply (simp add: length_app_decompo)
   apply (simp add: event_in_trace Abs_trace_inverse)
  apply (simp add: Abs_dom_T_inverse)

  (* lengtht (sa @t t) = n *)
  apply (rule disjI2)
  apply (rule_tac x="sa" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

  (* F2 *)
  apply (simp add: rest_F_def)
  apply (simp add: subset_F_def)
  apply (simp add: restFset_in Abs_dom_F_inverse)
  apply (simp add: restFset_def)

  apply (rotate_tac -7)
  apply (erule subsetE)
  apply (drule_tac x="(t, X)" in bspec)
   apply (simp add: Abs_dom_F_inverse)
   apply (simp add: length_app_decompo)
   apply (elim conjE exE)
   apply (insert trace_nil_or_Tick_or_Ev)
   apply (drule_tac x="sa" in spec)

   (* []t *)
    apply (erule disjE)
    apply (simp add: nil_in_trace Abs_trace_inverse Rep_trace_inverse)
    apply (rule_tac x="s'" in exI)
    apply (simp)

   (* [Tick]t --> contra *)
    apply (erule disjE)
    apply (simp add: event_in_trace Abs_trace_inverse)

   (* [Ev a]t @t s *)
    apply (elim exE)
    apply (simp add: notick_Ev length_app_decompo)
    apply (simp add: event_in_trace Abs_trace_inverse)

  apply (simp add: Abs_dom_F_inverse)

  (* T1 *)
  apply (simp add: rest_T_def)
  apply (simp add: subset_T_def)
  apply (simp add: restTset_in Abs_dom_T_inverse)
  apply (simp add: restTset_def)
  apply (erule subsetE)
  apply (drule_tac x="sa @t [Tick]t" in bspec)

   apply (simp add: Abs_dom_T_inverse)
   apply (simp add: length_app_decompo)
   apply (erule conjE)
   apply (erule exE)
   apply (simp)

   apply (drule_tac x="t" in spec)

   (* []t --> contra *)

    apply (erule disjE)
    apply (simp add: nil_in_trace Abs_trace_inverse Rep_trace_inverse)
    apply (simp add: trace_app_in_trace_if Abs_trace_inverse)
    apply (simp add: event_in_trace Abs_trace_inverse)

   (* [Tick]t *)
    apply (erule disjE)
    apply (simp)

   (* [Ev a]t @t s *)

    apply (elim exE)
    apply (simp add: notick_Ev length_app_decompo)
    apply (simp add: event_in_trace Abs_trace_inverse)

  apply (simp add: Abs_dom_T_inverse)
done

(*** (=) ***)

lemma rest_Sequencef :
  "ALL S1 E1 E2 T1 F1 F2 n. 
         S1:dom_T & E1:dom_F & E2:dom_F & T1:dom_T & F1:dom_F & F2:dom_F &
        (Abs_dom_T S1) rest n = (Abs_dom_T T1) rest n &
        (Abs_dom_F E1) rest n = (Abs_dom_F F1) rest n &
        (Abs_dom_F E2) rest n = (Abs_dom_F F2) rest n
     --> Abs_dom_F ((S1, E1) ;;f E2) rest n = 
         Abs_dom_F ((T1, F1) ;;f F2) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Sequencef_sub)
done

(*********************************************************
                      dis Sequencet
 *********************************************************)

lemma dis_Sequencet:
  "ALL S1 S2 T1 T2.
       distance(Abs_dom_T (Rep_dom_T S1 ;;t Rep_dom_T S2), 
                Abs_dom_T (Rep_dom_T T1 ;;t Rep_dom_T T2))
       <= max (distance(S1, T1)) (distance(S2, T2))"

apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(S1,T1), (S2,T2)}" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T S1 ;;t Rep_dom_T S2)" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T T1 ;;t Rep_dom_T T2)" in spec)
apply (insert rest_Sequencet)
apply (drule_tac x="Rep_dom_T S1" in spec)
apply (drule_tac x="Rep_dom_T S2" in spec)
apply (drule_tac x="Rep_dom_T T1" in spec)
apply (drule_tac x="Rep_dom_T T2" in spec)
apply (simp add: Rep_dom_T Rep_dom_T_inverse)
apply (auto simp add: max_def)
done

lemma dis_Sequencet_TF:
  "ALL SE1 SE2 TF1 TF2.
       distance(Abs_dom_T (Rep_dom_T (fst SE1) ;;t Rep_dom_T (fst SE2)), 
                Abs_dom_T (Rep_dom_T (fst TF1) ;;t Rep_dom_T (fst TF2)))
       <= max (distance(SE1, TF1)) (distance(SE2, TF2))"
apply (intro allI)
apply (insert dis_Sequencet)
apply (drule_tac x="fst SE1" in spec)
apply (drule_tac x="fst SE2" in spec)
apply (drule_tac x="fst TF1" in spec)
apply (drule_tac x="fst TF2" in spec)

apply (subgoal_tac 
  "max (distance (fst SE1, fst TF1)) (distance (fst SE2, fst TF2))
   <= max (distance (SE1, TF1)) (distance (SE2, TF2))")
apply (blast intro: order_trans)
apply (simp add: pair_distance)
apply (auto simp add: max_def)
done

(*********************************************************
                      dis Sequencef
 *********************************************************)

lemma dis_Sequencef:
  "ALL SE1 (SE2::('a dom_T * 'a dom_F)) TF1 (TF2::('a dom_T * 'a dom_F)).
       distance(Abs_dom_F ((Rep_dom_T (fst SE1), Rep_dom_F (snd SE1))
                           ;;f Rep_dom_F (snd SE2)), 
                Abs_dom_F ((Rep_dom_T (fst TF1), Rep_dom_F (snd TF1))
                           ;;f Rep_dom_F (snd TF2)))
       <= max (distance(SE1, TF1)) (distance(SE2, TF2))"

apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(SE1,TF1), (SE2,TF2)}" in spec)
apply (drule_tac x="Abs_dom_F ((Rep_dom_T (fst SE1), Rep_dom_F (snd SE1)) 
                               ;;f Rep_dom_F (snd SE2))" in spec)
apply (drule_tac x="Abs_dom_F ((Rep_dom_T (fst TF1), Rep_dom_F (snd TF1))
                               ;;f Rep_dom_F (snd TF2))" in spec)
apply (insert rest_Sequencef)
apply (drule_tac x="Rep_dom_T (fst SE1)" in spec)
apply (drule_tac x="Rep_dom_F (snd SE1)" in spec)
apply (drule_tac x="Rep_dom_F (snd SE2)" in spec)
apply (drule_tac x="Rep_dom_T (fst TF1)" in spec)
apply (drule_tac x="Rep_dom_F (snd TF1)" in spec)
apply (drule_tac x="Rep_dom_F (snd TF2)" in spec)

apply (simp add: Rep_dom_F Rep_dom_F_inverse Rep_dom_T Rep_dom_T_inverse
            del: split_paired_Ex)
apply (drule mp)

apply (intro allI impI)
apply (drule_tac x="n" in spec)
apply (simp add: pair_restriction_def)
apply (auto simp add: max_def)
done

(*********************************************************
                      dis Sequencesf
 *********************************************************)

lemma dis_Sequencesf:
  "ALL SE1 TF1 SE2 TF2.
       distance(SE1 ;;sf SE2, TF1 ;;sf TF2)
       <= max (distance(SE1, TF1)) (distance(SE2, TF2))"
apply (intro allI impI)
apply (simp add: Sequencesf_def)

      (* dom_T part *)

apply (insert dis_Sequencet_TF)
apply (drule_tac x="SE1" in spec)
apply (drule_tac x="SE2" in spec)
apply (drule_tac x="TF1" in spec)
apply (drule_tac x="TF2" in spec)

      (* dom_F part *)

apply (insert dis_Sequencef)
apply (drule_tac x="SE1" in spec)
apply (drule_tac x="SE2" in spec)
apply (drule_tac x="TF1" in spec)
apply (drule_tac x="TF2" in spec)

  (* solve max *)

apply (case_tac "distance (SE1, TF1)
              <= distance (SE2, TF2)")
apply (simp add: max_def)
apply (simp add: pair_distance)

apply (simp add: max_def)
apply (simp add: pair_distance)
done

end
