           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_step2 = Csp_relation_def:

(*****************************************************************

         1. step laws
         2.
         3. 
         4. 

 *****************************************************************)

consts
  Rename_step ::
      "('a * 'a) set => 'a set => ('a => ('n,'a) proc) => ('n,'a) proc"

defs
  Rename_step_def :
   "Rename_step r X Pf ==
      ? y:(r `` X) -> (! x:{x. x:X & (x,y):r} .. (Pf x)[[r]])"

consts
  Sequence_step ::
      "'a set => ('a => ('n,'a) proc) => ('n,'a) proc => ('n,'a) proc"

defs
  Sequence_step_def :
   "Sequence_step X Pf Q == ? x:X -> (Pf x ;; Q)"

(*********************************************************
                      Rename expansion
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_Renamet_step_subset: 
  "[[(? :X -> Pf) [[r]]]]T ev <= [[Rename_step r X Pf]]T ev"
apply (simp add: Rename_step_def)
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (rule subsetI)
apply (simp)
apply (erule bexE)

apply (simp add: Pre_choicet_eval)
apply (erule disjE)

         (* t = []t *)

apply (simp add: ren_to_nil)

         (* t = [Ev a]t @t t'; a : Y; t' : [[P]]T ev *)

apply (elim conjE exE)
apply (rule disjI2)

apply (insert ren_decompo_to)
apply (drule_tac x="r" in spec)
apply (drule_tac x="[Ev a]t" in spec)
apply (drule_tac x="sa" in spec)
apply (drule_tac x="x" in spec)
apply (drule mp)
apply (simp add: event_in_trace Abs_trace_inverse)
apply (elim conjE exE)
apply (simp)

apply (insert ren_to_Ev)
apply (drule_tac x="r" in spec)
apply (drule_tac x="t1" in spec)
apply (drule_tac x="a" in spec)
apply (simp)
apply (elim conjE exE)
apply (simp)

apply (rule_tac x="b" in exI)
apply (rule_tac x="t2" in exI)
apply (simp add: Image_iff)
apply (rule conjI)
apply (rule_tac x="a" in bexI)
apply (simp)
apply (simp)

apply (simp add: Int_bindt_eval)
apply (rule disjI2)

apply (rule_tac x="[[Pf a [[r]]]]T ev" in exI)
apply (rule conjI)

apply (rule_tac x="a" in exI)
apply (simp)

apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (rule_tac x="sa" in bexI)
apply (simp)
apply (simp)
done

(*** trace part (supset) ***)

lemma eq_Renamet_step_supset: 
  "[[Rename_step r X Pf]]T ev <= [[(? :X -> Pf) [[r]]]]T ev"
apply (simp add: Rename_step_def)
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (rule subsetI)

apply (simp add: Pre_choicet_eval)
apply (erule disjE)

 (* t = []t *)
 apply (simp add: ren_nil)

 (* t = [Ev a]t @t t'; a : Y; t' : [[P]]T ev *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (simp add: Int_bindt_eval)

  (* s = []t *)
  apply (erule disjE)
  apply (simp add: trace_app_nil)
  apply (simp add: Image_iff)
  apply (erule bexE)

  apply (rule_tac x="[Ev xa]t" in exI)
  apply (rule conjI)

   apply (rule_tac x="xa" in exI)
   apply (rule_tac x="[]t" in exI)
   apply (simp add: trace_app_nil)
   apply (simp add: eval_T_in nil_t_in_all_dom)

   apply (simp add: ren_check_def)
   apply (simp add: event_in_trace Abs_trace_inverse)
   apply (simp add: addTick_def)

  (* [Ev a]t @t s -- prefix2 *)
 apply (elim conjE exE)

 apply (simp add: Renamet_eval)
 apply (simp add: Renamet_def)
 apply (erule bexE)
 apply (rename_tac s a s' Q b t')

 apply (rule_tac x="[Ev b]t @t t'" in exI)
 apply (simp add: ren_app_event)

apply (rule_tac x="b" in exI)
apply (rule_tac x="t'" in exI)
apply (simp)
done

(*** trace part ***)

lemma eq_Renamet_step:
  "[[(? :X -> Pf) [[r]]]]T ev = [[Rename_step r X Pf]]T ev"
apply (rule equalityI)
apply (simp add: eq_Renamet_step_subset)
apply (simp add: eq_Renamet_step_supset)
done

(*******************************
        failure part
 *******************************)

lemma eq_Renamef_step_subset: 
  "[[(? :X -> Pf) [[r]]]]F ev <= [[Rename_step r X Pf]]F ev"
apply (simp add: Rename_step_def)
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (rule subsetI)
apply (simp add: pair_fun_apply)
apply (elim conjE exE)

apply (simp add: Pre_choicef_eval)
apply (erule disjE)

         (* t = []t *)

apply (simp)
apply (rule disjI1)
apply (rule_tac x="snd x" in exI)
apply (simp add: ren_to_nil eq_pair_decompo)
apply (simp add: invrelfun_def)
apply (simp add: addTick_def)
apply (force)

         (* [Ev a]t @t sa  *)

apply (elim conjE exE)
apply (rule disjI2)

apply (insert ren_decompo_to)
apply (drule_tac x="r" in spec)
apply (drule_tac x="[Ev a]t" in spec)
apply (drule_tac x="sa" in spec)
apply (drule_tac x="fst x" in spec)
apply (drule mp)
apply (simp add: event_in_trace Abs_trace_inverse)
apply (elim conjE exE)
apply (simp)

apply (insert ren_to_Ev)
apply (drule_tac x="r" in spec)
apply (drule_tac x="t1" in spec)
apply (drule_tac x="a" in spec)
apply (simp)
apply (elim conjE exE)
apply (simp)

apply (rule_tac x="b" in exI)
apply (rule_tac x="t2" in exI)
apply (rule_tac x="snd x" in exI)
apply (simp add: Image_iff)
apply (simp add: eq_pair_decompo)

apply (rule conjI)
apply (rule_tac x="a" in bexI)
apply (simp)
apply (simp)

apply (simp add: Int_bindf_eval)
apply (rule_tac x="[[Pf a [[r]]]]F ev" in exI)
apply (rule conjI)

apply (rule_tac x="a" in exI)
apply (simp)

apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (rule_tac x="sa" in exI)
apply (simp)
done

(*** failure part (supset) ***)

lemma eq_Renamef_step_supset: 
  "[[Rename_step r X Pf]]F ev <= [[(? :X -> Pf) [[r]]]]F ev"
apply (simp add: Rename_step_def)
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (rule subsetI)
apply (simp add: Pre_choicef_eval)
apply (simp add: pair_fun_apply)
apply (erule disjE)

         (* t = []t *)
 apply (erule exE)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: ren_nil)
 apply (rule disjI1)
 apply (simp add: invrelfun_def addTick_def)
 apply (force)

         (* [Ev a]t @t s  *)

 apply (elim conjE exE)
 apply (simp add: Int_bindf_eval)

 apply (elim conjE exE)

 apply (simp add: Renamef_eval)
 apply (simp add: Renamef_def)
 apply (elim conjE exE)

 apply (rule_tac x="[Ev aa]t @t sa" in exI)
 apply (simp add: ren_app_event)
 apply (rule disjI2)
 apply (rule_tac x="aa" in exI)
 apply (rule_tac x="sa" in exI)
 apply (simp)
done

(*** failure part ***)

lemma eq_Renamef_step: 
  "[[(? :X -> Pf) [[r]]]]F ev = [[Rename_step r X Pf]]F ev"
apply (rule equalityI)
apply (simp add: eq_Renamef_step_subset)
apply (simp add: eq_Renamef_step_supset)
done

(*** proc ***)

lemma eq_Rename_step:
  "(? :X -> Pf) [[r]] =F<ev> Rename_step r X Pf"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Renamet_step)
apply (simp add: eq_Renamef_step)
done

(*********************************************************
                  Sequence expansion
 *********************************************************)

(*******************************
         trace part
 *******************************)

(*** trace part (subset) ***)

lemma eq_Sequencet_step_subset: 
  "[[(? :X -> Pf) ;; Q]]T ev <= [[Sequence_step X Pf Q]]T ev"
apply (simp add: Sequence_step_def)
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)
apply (simp)

 (* rmtick s *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (simp add: Pre_choicet_eval)
 apply (erule disjE)

  (* t = []t *)
  apply (simp add: nil_in_trace Abs_trace_inverse)

  (* t = [Ev a]t @t t'; a : Y; t' : [[P]]T ev *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="rmtick sa" in exI)
  apply (simp add: rmtick_app_dist_event)

  apply (simp add: Sequencet_eval)
  apply (simp add: Sequencet_def)
  apply (rule disjI1)
  apply (rule_tac x="sa" in exI)
  apply (simp)

 (* x = s @t t *)
 apply (elim conjE exE)
 apply (simp add: Pre_choicet_eval)
 apply (erule disjE)
  apply (simp add: trace_app_in_trace_if nil_in_trace Abs_trace_inject)
  apply (simp add: event_in_trace Abs_trace_inverse)

  apply (elim conjE exE)
  apply (rule disjI2)

  apply (insert trace_last_nil_or_unnil)
  apply (drule_tac x="sa" in spec)
  apply (erule disjE)
   (* --> contra *)
   apply (simp add: trace_app_nil)
   apply (simp add: trace_app_in_trace_if event_in_trace Abs_trace_inject)
   apply (simp add: event_in_trace Abs_trace_inverse)

   (* sa = sb @t [aa]t *)
   apply (elim conjE exE)

   apply (rule_tac x="a" in exI)
   apply (rule_tac x="sb @t t" in exI)

   apply (simp add: notick_Ev app_trace_notick_ass)
   apply (insert app_trace_same_last)
   apply (drule_tac x="s" in spec)
   apply (drule_tac x="Tick" in spec)
   apply (drule_tac x="[Ev a]t @t sb" in spec)
   apply (drule_tac x="aa" in spec)
   apply (drule mp)
   apply (simp add: app_trace_notick_notick notick_Ev)

   apply (simp add: Sequencet_eval)
   apply (simp add: Sequencet_def)
   apply (rule disjI2)
   apply (rule_tac x="sb" in exI)
   apply (rule_tac x="t" in exI)
   apply (simp)
done

(*** trace part (supset) ***)

lemma eq_Sequencet_step_supset: 
  "[[Sequence_step X Pf Q]]T ev <= [[(? :X -> Pf) ;; Q]]T ev"
apply (simp add: Sequence_step_def)
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (rule subsetI)

apply (simp add: Pre_choicet_eval)
apply (erule disjE)

 (* t = []t *)
 apply (rule disjI1)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: Abs_trace_inverse nil_in_trace)

 (* t = [Ev a]t @t t'; a : Y; t' : [[P]]T ev *)
 apply (elim conjE exE)
 apply (simp add: Sequencet_eval)
 apply (simp add: Sequencet_def)
 apply (erule disjE)

  (* s = rmtick sa *)
  apply (elim conjE exE)
  apply (rule disjI1)
  apply (rule_tac x="[Ev a]t @t sa" in exI)
  apply (simp add: rmtick_app_dist_event)
  apply (rule disjI2)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="sa" in exI)
  apply (simp)

  (* s = sa @t t *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="[Ev a]t @t sa" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp add: notick_Ev app_trace_notick_ass)
  apply (simp add: notick_Ev app_trace_notick_notick)
  apply (rule disjI2)

  apply (rule_tac x="a" in exI)
  apply (rule_tac x=" sa @t [Tick]t" in exI)
  apply (simp add: notick_Ev app_trace_notick_ass)
done

(*** trace part ***)

lemma eq_Sequencet_step: 
  "[[(? :X -> Pf) ;; Q]]T ev = [[Sequence_step X Pf Q]]T ev"
apply (rule equalityI)
apply (simp add: eq_Sequencet_step_subset)
apply (simp add: eq_Sequencet_step_supset)
done

(*******************************
         failure part
 *******************************)

(*** failure part (subset) ***)

lemma eq_Sequencef_step_subset: 
  "[[(? :X -> Pf) ;; Q]]F ev <= [[Sequence_step X Pf Q]]F ev"
apply (simp add: Sequence_step_def)
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)
apply (simp)

 (* rmtick s *)
 apply (erule disjE)
 apply (simp add: pair_fun_apply)
 apply (simp add: Pre_choicef_eval)
 apply (erule conjE)
 apply (erule disjE)

  (* fst x = []t *)
  apply (rule disjI1)
  apply (rule_tac x="snd x" in exI)
  apply (simp add: eq_pair_decompo)

  (* fst x = [Ev a]t @t s *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="snd x" in exI)
  apply (simp add: eq_pair_decompo)

  apply (simp add: Sequencef_eval)
  apply (simp add: Sequencef_def del: disj_not1)
  apply (rule disjI1)
  apply (insert app_trace_notick_notick_inv)

  apply (drule_tac x="[Ev a]t" in spec)
  apply (drule_tac x="s" in spec)
  apply (simp add: notick_Ev)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: Pre_choicet_eval)
 apply (erule disjE)

  (* []t --> contra *)
  apply (simp add: app_t_nil)
  apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)

  (* s @t [Tick]t = [Ev a]t @t sa *)
  apply (elim conjE exE)

  apply (simp add: Pre_choicef_eval)
  apply (insert trace_last_nil_or_unnil)
  apply (rotate_tac -1)

  apply (drule_tac x="sa" in spec)
  apply (erule disjE)
   (* --> contra *)

   apply (simp add: trace_app_nil)
   apply (simp add: trace_app_in_trace_if event_in_trace Abs_trace_inject)
   apply (simp add: event_in_trace Abs_trace_inverse)

   (* sa = sb @t [aa]t *)
   apply (elim conjE exE)
   apply (rule disjI2)

   apply (rule_tac x="a" in exI)
   apply (rule_tac x="sb @t t" in exI)

   apply (simp add: notick_Ev app_trace_notick_ass)
   apply (insert app_trace_same_last)
   apply (rotate_tac -1)
   apply (drule_tac x="s" in spec)
   apply (drule_tac x="Tick" in spec)
   apply (rotate_tac -1)
   apply (drule_tac x="[Ev a]t @t sb" in spec)
   apply (drule_tac x="aa" in spec)
   apply (drule mp)
   apply (simp add: app_trace_notick_notick notick_Ev)

   apply (simp add: Sequencef_eval)
   apply (simp add: Sequencef_def)
   apply (rule disjI2)
   apply (rule_tac x="sb" in exI)
   apply (rule_tac x="t" in exI)
   apply (simp)
done

(*** failure part (supset) ***)

lemma eq_Sequencef_step_supset: 
  "[[Sequence_step X Pf Q]]F ev <= [[(? :X -> Pf) ;; Q]]F ev"
apply (simp add: Sequence_step_def)
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule subsetI)

apply (simp add: Pre_choicef_eval)
apply (erule disjE)

 (* t = []t *)
 apply (rule disjI1)
 apply (elim conjE exE)
 apply (simp add: pair_fun_apply del: disj_not1)
 apply (rule conjI)
 apply (simp add: Abs_trace_inverse nil_in_trace)
 apply (rule disjI1)
 apply (simp add: image_iff)

 (* [Ev a]t @t s *)
 apply (elim conjE exE)

 apply (simp add: Sequencef_eval)
 apply (simp add: Sequencef_def del: disj_not1)
 apply (erule disjE)

  (* (s, insert Tick Y) : [[Pf a]]F ev *)
  apply (elim conjE exE)
  apply (simp add: app_trace_notick_notick notick_Ev)
  apply (rule disjI2)
  apply (rule disjI1)

  apply (rule_tac x="a" in exI)
  apply (rule_tac x="s" in exI)
  apply (simp)

  (* sa @t t *)
  apply (elim conjE exE)
  apply (rule disjI2)

  apply (rule_tac x="[Ev a]t @t sa" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp add: notick_Ev app_trace_notick_ass)
  apply (simp add: app_trace_notick_notick notick_Ev)

  apply (simp add: Pre_choicet_eval)
  apply (rule disjI2)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="sa @t [Tick]t" in exI)
  apply (simp add: notick_Ev app_trace_notick_ass)
done

(*** failure part ***)

lemma eq_Sequencef_step: 
  "[[(? :X -> Pf) ;; Q]]F ev = [[Sequence_step X Pf Q]]F ev"
apply (rule equalityI)
apply (simp add: eq_Sequencef_step_subset)
apply (simp add: eq_Sequencef_step_supset)
done

(*** proc ***)

lemma eq_Sequence_step:
  "(? :X -> Pf) ;; Q =F<ev> Sequence_step X Pf Q"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Sequencet_step)
apply (simp add: eq_Sequencef_step)
done

end
